              #include   <p12f629.inc>
              LIST        p=12F629          ;   .
              __CONFIG    03F81H            ;   4

Sec           equ         20h               ;  
Sec0          equ         21h               ;
Sec1          equ         22h               ;
kod           equ         24h               ;  
shetbit       equ         25h               ; 

                                            ;   -
#define       knp         GPIO,0            ;
#define       dat         GPIO,2            ;   
#define       enab        GPIO,1            ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0                 ;      0 PC.
              goto        Start             ;    Start.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
Start         movlw       b'00000111'       ; 
              movwf       CMCON             ;
              movlw       b'00000000'       ;      GPIO
              movwf       GPIO              ;
              bsf         STATUS,RP0        ; 1- 
              movlw       b'00111001'       ;  \  GPIO
              movwf       TRISIO            ;GP1,GP2 -  ,   
              bsf         IOCB,IOCB0        ;       GP0                             
              bcf         STATUS,RP0        ; 0- 
                 
son           movf        GPIO,W            ;  GPIO   
              bcf         INTCON,GPIF       ;       GP0-GP5
              bsf         INTCON,GPIE       ;      GP0-GP5
              SLEEP                         ;   
         
metka3        btfsc       knp               ;  
              goto        metka4            ; ( ):   metka4
              call        nagat             ; ( ):  comm_psk
              call        paus200           ;   200             
              goto        metka3            ;   metka3:  
metka4        call        pausknp           ;   10
              goto        son               ;   son
                                                                          
nagat         bsf         enab              ; 
              call        pausknp           ;   10
              call        preamb            ;   
              movlw       .196              ;  196  
              call        send              ;
              movlw       .46               ;  46  
              call        send              ; 
              bcf         enab              ; 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    
;  833 /

send          movwf       kod               ;     kod
              movlw       .8                ;  8   shetbit,   
              movwf       shetbit           ;  
opros         btfsc       kod,7             ; 7-   kod
              goto        prdedin           ;  1:   prdedin 

prdnol        bcf         dat               ;  0:  
              call        paus800
              bsf         dat
              call        paus400
              goto        metka1
                          
prdedin       bcf         dat               ;  
              call        paus400
              bsf         dat
              call        paus800

metka1        rlf         kod,F             ;   kod   
                                            ; 
              decfsz      shetbit,F         ;   
              goto        opros             ;   :   opros
              bcf         dat               ;  :   dat(   
                                            ;    )
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

preamb        movlw       .12               ;    -
              movwf       shetbit           ;-      
bb1           bcf         dat               ;(010101...01) 24  - 3 
              call        paus400
              bsf         dat
              call        paus400
              decfsz      shetbit,F
              goto        bb1
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pausknp       movlw       .13               ;  10 
              movwf       Sec
a2            movlw       .255
              movwf       Sec0
a1            decfsz      Sec0,F
              goto        a1
              decfsz      Sec,F
              goto        a2
              return

paus400       movlw       .132              ;  400
              movwf       Sec0
aa1           decfsz      Sec0,F
              goto        aa1
              return 

paus800       movlw       .4                ;  800
              movwf       Sec0
aa3           movlw       .66              
              movwf       Sec
aa2           decfsz      Sec,F
              goto        aa2
              decfsz      Sec0,F
              goto        aa3
              return 

paus200       movlw       .4                ;  200
              movwf       Sec
as2           movlw       .65
              movwf       Sec0
as3           movlw       .255
              movwf       Sec1
as1           decfsz      Sec1,F
              goto        as1
              decfsz      Sec0,F
              goto        as3
              decfsz      Sec,F
              goto        as2
              return

              End                           ;  

