              #include <P12F629.INC>
              LIST        P=12F629     
              __CONFIG    H'3F81'           ;   4    
                                     
            
flag          equ         20h               ;  
vremya        equ         21h               ;   
kolbyte       equ         22h               ; -  
reg           equ         23h               ;    
shets         equ         24h               ; -  

FSR_osn       equ         25h               ;     
FSR_prer      equ         26h               ;  
W_TEMP        equ         27h               ;
STATUS_TEMP   equ         28h               ;

data1         equ         50h               ;    

                                            ;   -
#DEFINE       dat         GPIO,0            ;   
#DEFINE       led         GPIO,2            ; 
#DEFINE       regim       GPIO,3            ; 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  
;   833 /,    1,2 

              org         0004h             ;     0004h
                                            ;
              btfss       PIR1,TMR1IF       ;     TMR1
              goto        int0              ;  :   int0 
              bcf         T1CON,TMR1ON      ; :  TMR0
              bcf         PIR1,TMR1IF       ;     TMR1
              bcf         led               ; 
              retfie                        ;    
              
int0          movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;           
                 
              movf        TMR0,W            ;   TMR0 
              movwf       vremya            ;  vremya 
              movlw       .0                ;  0   TMR0
              movwf       TMR0 

              movf        FSR,W             ;   FSR 
              movwf       FSR_osn           ; FSR_osn
              movf        FSR_prer,W        ;   FSR_prer 
              movwf       FSR               ; FSR

              btfsc       INTCON,T0IF       ;     TMR0
              goto        outshet           ; TMR0:   outshet

              btfss       dat               ;  TMR0:   
              bcf         flag,0            ;dat  0-   flag1
              btfsc       dat
              bsf         flag,0

             
              movlw       .60               ;  
              subwf       vremya,W          ;:- 240
              btfss       STATUS,C          ;
              goto        eror              ;  240:   eror
              movlw       .140              ;  240: : 
              subwf       vremya,W          ;- 560
              btfsc       STATUS,C          ;
              goto        int1              ;  560:   int1
              bcf         flag,1            ;  560: 1-   flag:
                                            ;   400
              goto        opred             ;   opred
int1          movlw       .160              ; : - 640
              subwf       vremya,W          ;
              btfss       STATUS,C          ;
              goto        eror              ;  640:   eror
              movlw       .240              ;  640: : 
              subwf       vremya,W          ;- 960
              btfsc       STATUS,C          ;
              goto        eror              ;  960:   eror
              bsf         flag,1            ;  960: 1-   
                                            ;flag:   800
opred         btfss       flag,0            ;     dat
              goto        int2              ;   dat:   int2
              btfsc       flag,1            ;   dat(  - 
                                            ;-  ):  
              bsf         flag,2            ; 2-   flag: 
              btfss       flag,1            ;   800
              bcf         flag,2            ; 2-   flag: 
                                            ;   400
              bsf         flag,7            ; 7-   flag: 
                                            ;     -
                                            ;-    
              goto        vihod             ;   vihod

int2          btfss       flag,7            ;   dat:(  -
                                            ;-  ):    
                                            ; 
              goto        vihod             ;     :  
                                            ; vihod
              btfsc       flag,2            ;     :- 
                                            ;-    
              goto        int3              ;    800:   int3
              btfss       flag,1            ;    400:  
                                            ;  
              goto        eror              ;   400(   400)-
                                            ;- :   eror 
              bsf         flag,3            ;   800(  400)- 
                                            ;-   (.1)
              goto        intpriem          ;   intpriem

int3          btfsc       flag,1            ;    800:  
                                            ;  
              goto        eror              ;   800(   800)-
                                            ;- :   eror 
              bcf         flag,3            ;   400(  800)-
                                            ;-   (.0)

intpriem      btfsc       flag,3            ;       0- -
              bsf         reg,0             ;- reg
              btfss       flag,3            ;
              bcf         reg,0             ;
              incf        shets,F           ;  (shets)  
              movlw       .8                ;  (shets)     
              xorwf       shets,W           ;  8
              btfsc       STATUS,Z          ;
              goto        srav              ; , 8 (1 ):   srav
              rlf         reg,F             ; :  reg    
                                            ;   
              goto        vihod             ;   vihod

srav          movf        reg,W             ;   - 
              movwf       INDF              ;-  
              incf        FSR,F             ;  FSR:   
                                            ;
              clrf        shets             ;  
              incf        kolbyte,F         ;  -  
              movlw       .2                ;  (shets)    
              xorwf       kolbyte,W         ;  2
              btfss       STATUS,Z          ;
              goto        vihod             ; :   vihod
              bsf         flag,4            ; , 2 :  -
                                            ;-! 
              goto        eror              ;   eror

outshet       bcf         INTCON,T0IF       ;     TMR0
eror          clrf        shets             ;  
              clrf        kolbyte           ;  
              bcf         flag,7            ;     . 
              movlw       data1             ;     
              movwf       FSR               ;   FSR
 
vihod         movf        GPIO,W            ;  GPIO   
              bcf         INTCON,GPIF       ;      
                                            ; GPIO
             
kon1          movf        FSR,W             ;   FSR 
              movwf       FSR_prer          ; FSR_prer
              movf        FSR_osn,W         ;   FSR_osn 
              movwf       FSR               ; FSR

exxit         swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         clrf        GPIO              ;    GPIO
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'11111011'       ;  \  GPIO      
              movwf       TRISIO            ;GP2  ,  

              movlw       b'00000001'       ;    \      
              movwf       IOCB              ;    GP0

              movlw       b'10000001'       ;  TMR0 1:4, . 
              movwf       OPTION_REG        ; 

              bsf         PIE1,TMR1IE       ;    TMR1
              bcf         STATUS,RP0
           
              bcf         flag,5            ;    led
              bcf         flag,7            ;     .
              bcf         flag,4            ;    
              clrf        shets             ;  
              clrf        kolbyte           ;  
              movlw       data1             ;     
              movwf       FSR_prer          ;  FSR_prer
              
              movlw       b'00100000'       ;  TMR1 1:4, . 
              movwf       T1CON             ; 
              bcf         PIR1,TMR1IF       ;     TMR1

              bcf         INTCON,T0IF       ;     TMR0
              clrf        TMR0              ;   TMR0
              bsf         INTCON,T0IE       ;    TMR0

              movf        GPIO,W            ;  GPIO   
              bcf         INTCON,GPIF       ;        GPIO
              bsf         INTCON,GPIE       ;       GPIO
              bsf         INTCON,PEIE       ;   
              bsf         INTCON,GIE        ;  

opros         btfss       flag,4            ;   
              goto        opros             ;  :   opros
              bcf         flag,4            ; :   

              movlw       data1             ;       
              movwf       FSR               ; ,   
              movf        INDF,W            ;
              xorlw       .196              ;
              btfss       STATUS,Z          ;
              goto        opros             ;   :   opros
              incf        FSR,F             ;
             
              movf        INDF,W            ;
              xorlw       .46               ;
              btfss       STATUS,Z          ;
              goto        opros             ;   :   opros

                                            ;  
              btfsc       regim             ;  
              goto        int4              ; :   int4
              bsf         led               ; :  
              bcf         T1CON,TMR1ON      ;  TMR0
              clrf        TMR1L             ;  
              clrf        TMR1H             ;
              bsf         T1CON,TMR1ON      ;  TMR0
              goto        opros             ;   opros

int4          btfsc       flag,5            ;     led- 
              goto        pro21             ;-   
              bsf         led               ; 
              bsf         flag,5            ;   
              goto        opros             ;

pro21         bcf         led               ; 
              bcf         flag,5            ;   
              goto        opros             ;   opros

              end                           ;  